
#include <HCSR04.h>
UltraSonicDistanceSensor distanceSensorFront(4, 7);
UltraSonicDistanceSensor distanceSensorSide(3, 2);

#include <SoftPWM.h>
#define ENA A0  // Left motor enable (PWM)
#define ENB A3  // Right motor enable (PWM)
#define in1 A2  // Left motor direction
#define in2 A1  // Left motor direction
#define in3 5   // Right motor direction
#define in4 6   // Right motor direction
int leftSpeed = 0;
int rightSpeed = 0;

void setup() {
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(ENA, OUTPUT);
  pinMode(ENB, OUTPUT);
  Serial.begin(115200);

  SoftPWMBegin();
  SoftPWMSet(ENA, 0); // Start with 0 speed
  SoftPWMSet(ENB, 0);

  SoftPWMSetFadeTime(ALL, 500, 500);
  Serial.println("      ");
  Serial.println("      ");

  delay(3000);
}

void loop() {
  float distance = distanceSensorSide.measureDistanceCm();
  Serial.println(distance);
  
  while (distance < 20){
    setLeftMotorSpeed(100);
    setRightMotorSpeed(100);

    distance = distanceSensorSide.measureDistanceCm();
    Serial.println(distance);
    delay(50);
  }
  
  setLeftMotorSpeed(100);
  setRightMotorSpeed(0);
  delay(350);

  distance = distanceSensorFront.measureDistanceCm();
  Serial.println(distance);

  while (distance > 20){
    setLeftMotorSpeed(100);
    setRightMotorSpeed(100);

    distance = distanceSensorFront.measureDistanceCm();
    Serial.println(distance);
    delay(50);
  }

  setLeftMotorSpeed(0);
  setRightMotorSpeed(100);
  delay(500);
  setLeftMotorSpeed(0);
  setRightMotorSpeed(0);
  delay(10000);
}

void setLeftMotorSpeed(int x) {
  x = map(x, -100, 100, -225, 225);
  if (x > 0) {  // Forward
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
  } else if (x < 0) {  // Backward
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
  } else {  // Stop
    digitalWrite(in1, LOW);
    digitalWrite(in2, LOW);
  }
  SoftPWMSet(ENA, abs(x));
}

void setRightMotorSpeed(int x) {
  x = map(x, -100, 100, -200, 200);
  if (x > 0) {  // Forward
    digitalWrite(in3, LOW);
    digitalWrite(in4, HIGH);
  } else if (x < 0) {  // Backward
    digitalWrite(in3, HIGH);
    digitalWrite(in4, LOW);
  } else {  // Stop
    digitalWrite(in3, LOW);
    digitalWrite(in4, LOW);
  }
  SoftPWMSet(ENB, abs(x));
}